
'RS       C0    High - CMD, Low DATA
'Reset    C1
'CS       C2
'CLK      C3
'DAT      C4
'Vcc      3.3V
'GND
'Vdigital 3.3V
'LED+     10.5 V, 20 mA (max 30 mA)
'LED- (GND)

$regfile = "Cypress.dat"
$crystal = 24000000

Rs Alias P2.0
Res Alias P2.1
Cs Alias P2.2
Clk Alias P2.3
Dat Alias P2.4
Const Cmd = 1
Const D = 0
Const X1 = &H0800
Const X2 = &H0900
Const Y1 = &H0A00
Const Y2 = &H0B00
Dim A As Word
Dim Bb As Word
Dim R As Byte
Dim F As Word
Dim T As Byte
dim i as byte
dim j as byte

set CPUCS.4
set CPUCS.1
CKCON   = &H10
SCON0 =  &h50

PCON = PCON * &h7E ';    // SMOD0=0 Serial Port 0 baud rate double disable
TMOD  = TMOD + &h20  ';         // M1=1, Timer1 Mode 2 : 8-bit counter with auto-reload
TH1   =  246   ';         // Reload value for 38400 baud rate at
TR1   =  1  ';            // TCON.6 Start the Timer 1
TI   =  1   ';    // SCON0.1 Transmit interrupt flag.
RI   =  1   ';    // SCON0.0 Receive interrupt flag.

OEC = &Hff
Portccfg = 0
Wait 1



'##################################
'Start der S65-Ansteuerung
'##################################
Loops:
Res = 1
GOSUB Delay10ms 'Waitms 10
Res = 0                                                       'Reset
Cs = 1
Clk = 1
Dat = 1
Rs = Cmd

GOSUB Delay1ms 'Waitms 1
Res = 1                                                       'Reset End
GOSUB Delay10ms 'Waitms 10

Cs = 1                                                        'CS select, Start
GOSUB Delay1ms 'Waitms 1
Rs = Cmd                                                        'RS high, Command

' Display init

Restore Init1
For R = 1 To 12
Read A
Gosub Sendbyte
Next

Gosub Delay7ms

Restore Init2
For R = 1 To 23
Read A
Gosub Sendbyte
Next

Wait 5

Clear_screen:
A = &HEF90
Gosub Sendbyte
A = &H0500                                                    ' OR 04-0 degree, 00- 90 degrees
Gosub Sendbyte
A = &H0600                                                    'Y
Gosub Sendbyte
A = &H0700                                                    'X
Gosub Sendbyte
Rs = D
A = 0
For Bb = 1 To 23232
Gosub Sendbyte
Next Bb




Wait 5

'########################
'Color Bars
'########################

'Blue
Rs = Cmd
A = &HEF90
Gosub Sendbyte
A = &H0500                                                    '00 => Picture drawn from up to down
Gosub Sendbyte
A = X1 + 0                                                    'x1
Gosub Sendbyte
A = X2 + 43                                                   'x2
Gosub Sendbyte
A = Y1 + 0                                                    'y1
Gosub Sendbyte
A = Y2 + 175                                                  'y2
Gosub Sendbyte

Rs = D
F = 0


For A = 0 To 5631
Gosub Sendbyte
Next A

''For T = 1 To 32                                               '32 Farbabstufungen schwarz => blau
                                                              '32      =>  
''For R = 1 To 88                                               '2 Zeilen gleiche Farbe 2     
''A = F
''Gosub Sendbyte
''Next R
''F = F + 1
''Next T

''Wait 10
''F = 31

''For T = 1 To 32                                               '32 Farbabstufungen blau => weiss
''For R = 1 To 88                                               '2 Zeilen gleiche Farbe
''A = F
''Gosub Sendbyte
''Next R
''F = F + 2112
''Next T

Rs = Cmd
Wait 10
'Green

A = &HEF90
Gosub Sendbyte
A = &H0500
Gosub Sendbyte
A = &H082C                                                    'x1
Gosub Sendbyte
A = &H0957                                                    'x2
Gosub Sendbyte
A = &H0A00                                                    'y1
Gosub Sendbyte
A = &H0BAF                                                    'y2
Gosub Sendbyte


Rs = D
F = 0

For T = 1 To 32
For R = 1 To 88
A = F
Gosub Sendbyte
Next R
F = F + 64
Next T

F = 2016

For T = 1 To 32
For R = 1 To 88
A = F
Gosub Sendbyte
Next R
F = F + 2049
Next T

Cs = 1
Rs = Cmd
Wait 5
'Rot malen

A = &HEF90
Gosub Sendbyte
A = &H0500
Gosub Sendbyte
A = &H0858                                                    'x1
Gosub Sendbyte
A = &H0983                                                    'x2
Gosub Sendbyte
A = &H0A00                                                    'y1
Gosub Sendbyte
A = &H0BAF                                                    'y2
Gosub Sendbyte

Rs = D
F = 0

For T = 1 To 32
For R = 1 To 88
A = F
Gosub Sendbyte
Next R
F = F + 2048
Next T

F = 63488

For T = 1 To 32
For R = 1 To 88
A = F
Gosub Sendbyte
Next R
F = F + 65
Next T

Rs = Cmd
Wait 5
' Schwarz => weiss

A = &HEF90
Gosub Sendbyte
A = &H0504                                                    ' 04 => Bild wird von links nach rechts gemalt
Gosub Sendbyte
A = &H0800                                                    'x1
Gosub Sendbyte
A = &H0983                                                    'x2
Gosub Sendbyte
A = &H0A80                                                    'y1
Gosub Sendbyte
A = &H0BAF                                                    'y2
Gosub Sendbyte

Rs = D
F = 0

For T = 1 To 32                                               '32 Farbabstufungen schwarz => weiss
For R = 1 To 192                                              '2 Zeilen gleiche Farbe
A = F
Gosub Sendbyte
Next R
F = F + 2113
Next T

Rs = Cmd
Goto Loops
' cyan

A = &HEF90
Gosub Sendbyte
A = &H0504                                                    ' 04 => Bild wird von links nach rechts gemalt
Gosub Sendbyte
A = &H0880                                                    'x1
Gosub Sendbyte
A = &H0983                                                    'x2
Gosub Sendbyte
A = &H0A80                                                    'y1
Gosub Sendbyte
A = &H0B8F                                                    'y2
Gosub Sendbyte

Rs = D

For R = 1 To 64
A = 2047
Gosub Sendbyte
Next R

Rs = Cmd
Wait 5
' magenta

A = &HEF90
Gosub Sendbyte
A = &H0504                                                    ' 04 => Bild wird von links nach rechts gemalt
Gosub Sendbyte
A = &H0880                                                    'x1
Gosub Sendbyte
A = &H0983                                                    'x2
Gosub Sendbyte
A = &H0A90                                                    'y1
Gosub Sendbyte
A = &H0B9F                                                    'y2
Gosub Sendbyte

Rs = D

For R = 1 To 64
A = 64241
Gosub Sendbyte
Next R

Rs = Cmd
Wait 5
' gelb

A = &HEF90
Gosub Sendbyte
A = &H0504                                                    ' 04 => Bild wird von links nach rechts gemalt
Gosub Sendbyte
A = &H0880                                                    'x1
Gosub Sendbyte
A = &H0983                                                    'x2
Gosub Sendbyte
A = &H0AA0                                                    'y1
Gosub Sendbyte
A = &H0BAF                                                    'y2
Gosub Sendbyte

Rs = D

For R = 1 To 64
A = 65504
Gosub Sendbyte
Next R

Rs = Cmd

 Wait 5
Goto Loops

Powerdown
End

Sendbyte:                                                     '0 - MSB shifted in/out first when clock goes low
Cs = 0                                                        '1 - MSB shifted in/out first when clock goes high
Shiftout Dat , Clk , A , 0                                    '2 - LSB shifted in/out first when clock goes low
Cs = 1                                                        '3 - LSB shifted in/out first when clock goes high
Return

Sendbyte1:                                                    '0 - MSB shifted in/out first when clock goes low
Cs = 0                                                        '1 - MSB shifted in/out first when clock goes high
Shiftout Dat , Clk , A , 2                                    '2 - LSB shifted in/out first when clock goes low
Cs = 1                                                        '3 - LSB shifted in/out first when clock goes high
Return                                                       '

Delay1ms:
for i=1 to 5
Waitms 1
delay
next i
Return

Delay7ms:
For J = 1 To 7
GOSUB Delay1ms 'Waitms 1
next j
return

Delay10ms:
for j=1 to 10
GOSUB Delay1ms 'Waitms 1
next j
return



Init1:
Data &HFDFD% , &HFDFD%,
Data &HEF00%,
Data &HEE04% , &H1B04%,
Data &HFEFE% , &HFEFE%,
Data &HEF90% , &H4A04% , &H7F3F% , &HEE04% , &H4306%

Init2:
Data &HEF90% , &H0983% , &H0800% , &H0BAF% , &H0A00% , &H0500% , &H0600% , &H0700%,
Data &HEF00%,
Data &HEE0C%,
Data &HEF90% , &H0080%,
Data &HEFB0% , &H4902%,
Data &HEF00%,
Data &H7F01% , &HE181%,
Data &HE202%,
Data &HE276%,
Data &HE183%,
Data &H8001%,
Data &HEF90%,
Data &H0000%